<?php
// Database connection details
define('DB_HOST', 'localhost');
define('DB_USER', 'setmobile02_setlottodev');
define('DB_PASSWORD', 'aR9s3n0GO#');
define('DB_NAME', 'setmobile02_setlottodev');

// Function to establish PDO connection
function connectToDatabase() {
    try {
        $pdo = new PDO("mysql:host=" . DB_HOST . ";dbname=" . DB_NAME, DB_USER, DB_PASSWORD);
        $pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        return $pdo;
    } catch (PDOException $e) {
        die("Connection failed: " . $e->getMessage());
    }
}

function handle_opay_notification() {
    // Retrieve the OPay notification data
    $notification_data = json_decode(file_get_contents('php://input'), true);

    // Validate the notification data (optional)
    // Check for required fields and data integrity

    // Extract relevant data from the payload
    $amount = $notification_data['payload']['amount'];
    $transaction_state_id = "1";
    $transactionId = $notification_data['payload']['transactionId'];
    $reference = $notification_data['payload']['reference'];

    // Connect to the database
    $pdo = connectToDatabase();

    // Query the transactionable table
    $query = "SELECT * FROM transactionable WHERE entity_id = :reference AND gross = :gross";
    $stmt = $pdo->prepare($query);
    $stmt->bindParam(':reference', $reference, PDO::PARAM_STR);
    $stmt->bindParam(':gross', $amount, PDO::PARAM_INT);
    $stmt->execute();
    $transactionable = $stmt->fetch(PDO::FETCH_ASSOC);

    if ($transactionable['transaction_state_id']!="1") {
        // Update transactionable.transaction_state_id
        $update_query = "UPDATE transactionable SET balance = :balance, transaction_state_id = :transaction_state_id WHERE entity_id = :entity_id";
        $stmt = $pdo->prepare($update_query);
        $stmt->bindParam(':balance', $amount, PDO::PARAM_INT);
        $stmt->bindParam(':transaction_state_id', $transaction_state_id, PDO::PARAM_INT);
        //$stmt->bindParam(':json_data', json_encode($notification_data), PDO::PARAM_STR);
        $stmt->bindParam(':entity_id', $reference, PDO::PARAM_STR);
        $stmt->execute();

        // Update deposits table
        $update_deposits_query = "UPDATE deposits SET transaction_state_id = :transaction_state_id, json_data = :json_data, updated_at = NOW() WHERE json_data = :json_data";
        $stmt = $pdo->prepare($update_deposits_query);
        $stmt->bindParam(':transaction_state_id', $transaction_state_id, PDO::PARAM_INT);
        $stmt->bindParam(':json_data', $reference, PDO::PARAM_STR);
        $stmt->bindParam(':json_data', $reference, PDO::PARAM_STR);
        $stmt->execute();

        // Update wallets table
        $user_id = $transactionable['user_id'];
        
        //Select wallet balance
        $query = "SELECT fiat FROM wallets WHERE user_id = :user_id";
        $stmt = $pdo->prepare($query);
        $stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
        $stmt->execute();
        $walletbal = $stmt->fetch(PDO::FETCH_ASSOC);
	$newbalance = $walletbal['fiat'] + $amount;
	
        $update_wallets_query = "UPDATE wallets SET fiat = :amount WHERE user_id = :user_id";
        $stmt = $pdo->prepare($update_wallets_query);
        $stmt->bindParam(':amount', $newbalance, PDO::PARAM_STR);
        $stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
        if($stmt->execute())
        { echo "Wallet Updated <br>";}
        else
        {echo "Wallet Not Updated <br>";}
        

        // Send 200 OK response
        http_response_code(200);
        echo "Transaction updated successfully";
    } else {
        // Handle case where transactionable record is not found
        http_response_code(404); // Not Found
        echo "Transactionable record not found";
    }
}

// Call the function to handle the notification
handle_opay_notification();
?>