<?php

// Check if a redirect is in progress
if (isset($_SERVER['HTTP_REFERER']) && !empty($_SERVER['HTTP_REFERER'])) {
    $referrerUrl = $_SERVER['HTTP_REFERER'];

    // Parse the referrer URL into its components
    $urlComponents = parse_url($referrerUrl);

    // Extract additional parameters from the query string
    if (isset($urlComponents['query'])) {
        $queryParameters = [];
        parse_str($urlComponents['query'], $queryParameters);

        // Access the status and other parameters
        echo "Redirect came from: " . $referrerUrl . PHP_EOL;
        if (isset($queryParameters['status'])) {
            echo "Status: " . $queryParameters['status'] . PHP_EOL;
        }

        // Access other parameters (modify as needed)
        if (isset($queryParameters['payToken'])) {
            echo "payToken: " . $queryParameters['payToken'] . PHP_EOL;
        }
        if (isset($queryParameters['session'])) {
            echo "session: " . $queryParameters['session'] . PHP_EOL;
        }
    } else {
        echo "No query parameters found in the referrer URL.";
    }
} else {
    echo "No referrer information available.";
}
?>