<?php
require_once('connector.php');
function createOpayRequest($data){
// Validate incoming data (add more validation as needed)
if (empty($data['amount']) || empty($data['customer_email']) || empty($data['user_id']) || empty($data['username'])) {
    return json_encode(['error' => 'Missing required data']);}

// Generate a unique reference
$data['reference'] = uniqid();

//Static Data
$merchantId = "256624091158827";
$publicKey = "OPAYPUB17260488799240.646755712292528";
$svn = "77";
$currency = "NGN";
$ttype = "App\Models\Voucher";
$naira = "Nigerian Naira";
$stat1 = 1;
$stat0 = 0;
$fromwinning = "Deposit from Opay";
$transaction_state_id = 1;
$platform_id = 10000101;
$currencysymbol = "₦";
$currencyid = 10;
$activity_title = "DEPOSIT FROM OPAY";
$money_flow = "+";
$deposit_method_id = 9;

  // Prepare the request data
  $requestBody = [
    'country' => 'NG',
    'reference' => $data['reference'],
    'amount' => [
      "total" => $data['amount'] * 100, //Convert amount to kobo
      "currency" => 'NGN'
    ],
    'returnUrl' => 'https://setlottonig.com/dev/v6/opay/success',
    'callbackUrl' => 'https://setlottonig.com/dev/include/api/opay_callback.php',
    'cancelUrl' => 'https://setlottonig.com/dev/v6/opay/cancel',
    'expireAt' => 30,
    'userInfo' => [
      "userEmail" => $data['customer_email'],
      "userId" => $data['user_id'],
      "userName" => $data['username'],
    ],
    'product' => [
      "name" => 'Wallet Top Up',
      "description" => 'Setlotto Wallet Top Up'
    ],
    'payMethod' => '',
  ];

  // Construct the headers
  $headers = [
    'Content-Type:application/json',
    'Authorization: Bearer ' . $publicKey,
    'MerchantId:' . $merchantId,
  ];

  // Initialize cURL
  $curl = curl_init();

  // Set cURL options
  curl_setopt($curl, CURLOPT_URL, 'https://testapi.opaycheckout.com/api/v1/international/cashier/create');
  curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
  curl_setopt($curl, CURLOPT_POST, true);
  curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($requestBody));
  curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);

  // Execute the request
  $response = curl_exec($curl);

  // Check for errors
  if (curl_errno($curl)) {
    return json_encode(['error' => 'Error: ' . curl_error($curl)]);
  }

  // Close cURL
  curl_close($curl);

  // Parse the response
  $response = json_decode($response, true);

  // Check for successful response
  if (!isset($response['data']['cashierUrl'])) {
    return json_encode(['error' => 'Error creating OPay request']);
  }

  // Database insertions using prepared statements (replace connection logic)
  global $conn; // Assuming connection is established using `require_once('connector.php')`

  // Insert into transactionable table
  $sql_trnxs = "INSERT INTO transactionable
  (user_id, transactionable_id, transactionable_type, entity_id, entity_name, transaction_state_id, currency, activity_title, money_flow, gross, json_data, currency_symbol, currency_id)
  VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";

  $stmt_trnxs = $conn->prepare($sql_trnxs);
  $stmt_trnxs->bind_param("ssssssssssssssi", $data['user_id'], $data['reference'], $ttype, $data['reference'], $naira, 1, $currency, $activity_title, '+', $currencysymbol, $currencyid, json_encode($response));
  $stmt_trnxs->execute();
  $stmt_trnxs->close();

  // Insert into deposits table
  $sql_deposits = "INSERT INTO deposits
  (user_id, transaction_state_id, deposit_method_id, gross, fee, net, transaction_receipt, json_data, currency_id, wallet_id, message)
  VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";

  $stmt_deposits = $conn->prepare($sql_deposits);
  $stmt_deposits->bind_param("sssssssssssi", $data['user_id'], 1, $deposit_method_id, $data['amount'], 0, $data['amount'], $data['reference'], json_encode($response), $currencyid, $data['user_id'], "Deposit from Opay");
  $stmt_deposits->execute();
  $stmt_deposits->close();

  // Return the response to the frontend
  return json_encode(['success' => true, 'cashierUrl' => $response['data']['cashierUrl']]);
}

// Handle the POST request
if ($_SERVER['REQUEST_METHOD'] === 'POST') {
  // Get the JSON data from the frontend
  $data = json_decode(file_get_contents('php://input'), true);

  // Call the createOpayRequest function and process the response
  $response = createOpayRequest($data);

  // Handle the response
  if ($response) {
    // Process the response from OPay
    echo $response;
  } else {
    // Handle errors
    echo "Error processing request";
  }
}
?>