<?php
require_once('connector.php');
function createOpayRequest($data) {

$data['reference'] = uniqid();

//Static Data
$svn = "77";
$currency = "NGN";
$ttype = "App\Models\Voucher";
$naira = "Nigerian Naira";
$stat1 = 1;
$stat0 = 0;
$fromwinning = "Deposit from Opay";
$transaction_state_id = 1;
$platform_id = 10000101;
$currencysymbol = "₦";
$currencyid = 10;
$activity_title = "DEPOSIT FROM OPAY";
$money_flow = "+";
$deposit_method_id = 9;
$data['amount'] = $data['amount'] * 100;

  // Prepare the request data
  $requestBody = [
    'country' => 'NG',
    'reference' => $data['reference'],
    'amount' => [
      "total"=> $data['amount'],
      "currency"=> 'NGN'
    ],
    'returnUrl' => 'https://setlottonig.com/dev/v6/opay/success',
    'callbackUrl'=> 'https://setlottonig.com/dev/include/api/opay_callback.php',
    'cancelUrl' => 'https://setlottonig.com/dev/v6/opay/cancel',
    'expireAt' => 30,
    'userInfo' => [
      "userEmail"=> $data['customer_email'],
      "userId"=> $data['user_id'],
      "userName"=> $data['username'],
    ],
    'product' => [
      "name"=> 'Wallet Top Up',
      "description"=> 'Setlotto Wallet Top Up'
    ],
    'payMethod'=>'',
  ];

  // Construct the headers
  $headers = [
    'Content-Type:application/json',
    'Authorization: Bearer ' . $publicKey,
    'MerchantId:' . $merchantId,
  ];

  // Initialize cURL
  $curl = curl_init();

  // Set cURL options
  curl_setopt($curl, CURLOPT_URL, 'https://testapi.opaycheckout.com/api/v1/international/cashier/create'); // OPay API endpoint
  curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
  curl_setopt($curl, CURLOPT_POST, true);
  curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($requestBody));
  curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);

  // Execute the request
  $response = curl_exec($curl);

  // Check for errors
  if (curl_errno($curl)) {
    echo 'Error: ' . curl_error($curl);
  }

  // Close cURL
  curl_close($curl);

  // Parse the response
  $response = json_decode($response, true);

  // Check if the response contains the cashierUrl
  if (isset($response['data']['cashierUrl'])) {
    // Include the cashierUrl in the response to be sent back to the frontend
    $data['cashierUrl'] = $response['data']['cashierUrl'];
  }

  // Return the response to the frontend
  return json_encode($data);
}

// Handle the POST request
if ($_SERVER['REQUEST_METHOD'] === 'POST') {
  // Get the JSON data from the frontend
  $data = json_decode(file_get_contents('php://input'), true);

  // Call the createOpayRequest function and process the response
  $response = createOpayRequest($data);

  // Handle the response
  if ($response) {
    // Process the response from OPay
    echo $response;
  } else {
    // Handle errors
    echo "Error processing request";
  }
}
?>