<?php
// OPay merchant ID and secret key
$merchantId = "256624091158827";
$secretKey = "OPAYPRV17260488799240.9151846932451885";
$publicKey = "OPAYPUB17260488799240.646755712292528";

class CashierCreateController
{
    private $publickey;
    private $merchantId;
    private $url;

    public function __construct() {
        $this->merchantId = '256624091158827';
        $this->publickey = 'OPAYPUB17260488799240.646755712292528';
        $this->url = 'https://testapi.opaycheckout.com/api/v1/international/cashier/create';
    }

    public function test() {
        // Check if incoming data is set using isset
        if (isset($_POST['data'])) {
            // Decode the JSON data from POST request
            $data = json_decode($_POST['data'], true);

            // Validate the received data (optional)
            // You can add checks to ensure required fields like 'amount' and 'reference' exist

            // Use the received data to populate the request parameters
            $request_data = [
                'country' => 'NG',
                'reference' => $data['reference'],
                'amount' => [
                    "total" => $data['amount'],
                    "currency" => 'NGN',
                ],
                "returnUrl" => 'https://settlottonig.com/dev/iclude/opay_success.php',
                "callbackUrl" => 'https://settlottonig.com/dev/iclude/opay_success.php',
                "cancelUrl" => 'https://settlottonig.com/dev/iclude/opay_cancel.php',
                "expireAt" => 30,
                "userInfo" => [
                    "userEmail" => $data['customer_email'] ?? null, // Handle missing key with null
                    "userId" => $data['user_id'] ?? null, // Handle missing key with null
                    "userMobile" => '+2348312222222',
                    "userName" => $data['username'] ?? null, // Handle missing key with null
                ],
                'product' => [
                    "description" => 'SETLOTTO Wallet Top Up',
                    "name" => 'Wallet Top Up',
                ],
                'payMethod' => 'BankCard',
            ];

            // Log the request data before sending it to OPay
            $this->logRequestData($request_data);

            $data2 = (string) json_encode($request_data, JSON_UNESCAPED_SLASHES);
            $header = ['Content-Type:application/json', 'Authorization:Bearer ' . $this->publickey, 'MerchantId:' . $this->merchantId];
            $response = $this->http_post($this->url, $header, json_encode($request_data));

            // Handle the response
            if ($response !== false) {
                // Process the response successfully
                // ... (your logic here)
                return $response; // Return the response to the caller
            } else {
                // Handle errors or empty responses
                // Log the error or return an error message
                error_log("Error processing OPay response: " . $response);
                return false; // Or return a specific error code/message
            }
        } else {
            throw new Exception('Missing data parameter in request', 400); // Handle missing data with exception
        }
    }

    private function http_post ($url, $header, $data) {
        if (!function_exists('curl_init')) {
            throw new Exception('php not found curl', 500);
        }
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_TIMEOUT, 60);
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
        curl_setopt($ch, CURLOPT_HEADER, false);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
        $response = curl_exec($ch);
        $httpStatusCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
        $error=curl_error($ch);
        curl_close($ch);
        if (200 != $httpStatusCode) {
            error_log("Invalid HTTP status code: {$httpStatusCode}, response: $response, detail_error: " . $error);
        }
        return $response;
    }

    private function logRequestData($data) {
        // Implement your preferred logging mechanism here

        // Example using error_log (basic logging):
        console.log("OPay Request Data:", data);
        error_log(sprintf("OPay Request Data: %s\n", json_encode($data)));

        // Example using a dedicated logging library (recommended):
        // Use a library like Monolog or PSR-3 compliant logger for structured logging.
    }
}
?>

<?php
/*
function createOpayPayment($data) {
$merchantId = "256624091158827";
$secretKey = "OPAYPRV17260488799240.9151846932451885";
$publicKey = "OPAYPUB17260488799240.646755712292528";

    // Validate request data
    if (!isset($data['amount']) || !isset($data['reference']) || !isset($data['customer_email'])) {
        return ['error' => 'Invalid request data: Missing required fields'];
    }

    // Generate OPay request parameters
    $requestParams = [
        'country' => 'NG',
        'reference' => $data['reference'],
        'amount' => [
            "total"=> $data['amount'],
            "currency"=> 'NGN'
        ],
        'returnUrl' => 'https://settlottonig.com/dev/iclude/opay_success.php',
        'callbackUrl'=> 'https://settlottonig.com/dev/iclude/opay_success.php',
        'cancelUrl' => 'https://settlottonig.com/dev/iclude/opay_failed.php',
        'expireAt' => 30,
        'userInfo' => [
            "userEmail"=> $data['customer_email'],
            "userId"=> $data['user_id'],
            "userMobile"=> '080',
            "userName"=> $data['username'],
        ],
        'product' => [
            "name"=> 'Wallet Top Up',
            "description"=> 'Setlotto Wallet Top Up'
        ],
        'payMethod'=>'BankCard',
        //'signature' => generateSignature($requestParams, $secretKey) // Use secretKey for signing
    ];

    // Make HTTP request to OPay API
    $ch = curl_init('https://testapi.opaycheckout.com/api/v1/international/cashier/create');
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($requestParams));
    curl_setopt($ch, CURLOPT_HTTPHEADER, ['Content-Type:application/json', 'Authorization:Bearer '. $publicKey, 'MerchantId:'.$merchantId]);
    $response = curl_exec($ch);
    curl_close($ch);

    $responseData = json_decode($response, true);

    if (isset($responseData['status']) && $responseData['status'] === 'success') {
        // Redirect to OPay checkout page
        http_response_code(200);
        return ['success' => ['url' => $responseData['data']['url']]];
    } else {
        // Handle OPay API errors
        $errorMessage = 'Error initializing OPay transaction: ';
        if (isset($responseData['message'])) {
            $errorMessage .= $responseData['message'];
        } else {
            $errorMessage .= 'An unknown error occurred.';
        }
        return ['error' => $errorMessage];
    }
}

// Handle POST request
if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    $data = json_decode(file_get_contents('php://input'), true);
    $response = createOpayPayment($data);

    if (isset($response['error'])) {
        http_response_code(400); // Bad Request
    } else {
        http_response_code(200); // Success
    }

    echo json_encode($response);
}*/
?>