<?php
// Database connection details (consider storing in a separate file for security)
define('DB_HOST', 'localhost');
define('DB_USER', 'setmobile02_setlottodev');
define('DB_PASSWORD', 'aR9s3n0GO#');
define('DB_NAME', 'setmobile02_setlottodev');

// Function to establish PDO connection
function connectToDatabase() {
    try {
        $pdo = new PDO("mysql:host=" . DB_HOST . ";dbname=" . DB_NAME, DB_USER, DB_PASSWORD);
        $pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        return $pdo;
    } catch (PDOException $e) {
        die("Connection failed: " . $e->getMessage());
    }
}

// Function to create OPay request
function createOpayRequest($data) {
    $data['reference'] = uniqid();
    $url = 'https://testapi.opaycheckout.com/api/v1/international/cashier/create';

    // Static Data (consider storing in a separate config file)
    $merchantId = "256624091158827";
    $publicKey = "OPAYPUB17260488799240.646755712292528";

    // Prepare request data
    $requestBody = [
        'country' => 'NG',
        'reference' => $data['reference'],
        'amount' => [
            "total" => $data['amount'] * 100, // Convert amount to kobo
            "currency" => 'NGN'
        ],
        'returnUrl' => 'https://setlottonig.com/dev/v6/opay/success',
        'callbackUrl' => 'https://setlottonig.com/dev/include/api/opay_callback.php',
        'cancelUrl' => 'https://setlottonig.com/dev/v6/failed',
        'expireAt' => 30,
        'userInfo' => [
            "userEmail" => $data['customer_email'],
            "userId" => $data['user_id'],
            "userName" => $data['username'],
        ],
        'product' => [
            "name" => 'Wallet Top Up',
            "description" => 'Setlotto Wallet Top Up'
        ],
        'payMethod' => '',
    ];

    // Construct headers
    $headers = [
        'Content-Type:application/json; charset=UTF-8', // Set character encoding to UTF-8
        'Authorization: Bearer ' . $publicKey,
        'MerchantId:' . $merchantId,
    ];

    // Initialize cURL
    $curl = curl_init();

    // Set cURL options
    curl_setopt($curl, CURLOPT_URL, $url);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($curl, CURLOPT_POST, true);
    curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($requestBody));
    curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);

    // Execute the request
    $response = curl_exec($curl);

    // Check for cURL errors
    if (curl_errno($curl)) {
        return ['status' => 'error', 'message' => 'Error: ' . curl_error($curl)];
    }

    // Close cURL
    curl_close($curl);

    // Parse the response
    $responses = json_decode($response, true);

    // Check for cashierUrl and handle database operations
    if (isset($responses['data']['cashierUrl'])) {
        $data['cashierUrl'] = $responses['data']['cashierUrl'];

        $pdo = connectToDatabase();
        $OPay = 'Deposit from Opay';
        $trxState = '2';
        $deposit_method_id = 9;
        $currency = "NGN";
        $currency_name = 'Nigerian Naira';
        $money_flow = '+';
        $fee = 0;
        $currency_symbol = '₦';
        $currency_id = '10';

        try {
            // 1. Get wallet ID
            $wallet_query = "SELECT `id` FROM `wallets` WHERE `user_id` = ?";
            $stmt = $pdo->prepare($wallet_query);
            $stmt->bindParam(1, $data['user_id'], PDO::PARAM_INT);
            $stmt->execute();
            $wallet = $stmt->fetch(PDO::FETCH_ASSOC);

            if ($wallet) {
                $walletid = $wallet['id'];

                // 2. Insert into deposits table
                $deposit_query = "INSERT INTO `deposits` (`user_id`, `transaction_state_id`, `deposit_method_id`, `gross`, `fee`, `net`, `transaction_receipt`, `currency_id`, `currency_symbol`, `wallet_id`, `message`, `json_data`) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
                $stmt = $pdo->prepare($deposit_query);
                $stmt->bindParam(1, $data['user_id'], PDO::PARAM_INT);
                $stmt->bindParam(2, $trxState, PDO::PARAM_INT);
                $stmt->bindParam(3, $deposit_method_id, PDO::PARAM_INT);
                $stmt->bindParam(4, $data['amount'], PDO::PARAM_STR);
                $stmt->bindParam(5, $fee, PDO::PARAM_INT);
                $stmt->bindParam(6, $data['amount'], PDO::PARAM_STR);
                $stmt->bindParam(7, $OPay, PDO::PARAM_STR);
                $stmt->bindParam(8, $currency_id, PDO::PARAM_INT);
                $stmt->bindParam(9, $currency_symbol, PDO::PARAM_STR);
                $stmt->bindParam(10, $walletid, PDO::PARAM_INT);
                $stmt->bindParam(11, $OPay, PDO::PARAM_STR);
                $stmt->bindParam(12, $data['reference'], PDO::PARAM_STR);
                $stmt->execute();

                // 3. Insert into transactionable table
                $transactionable_query = "INSERT INTO `transactionable` (`user_id`, `entity_id`, `entity_name`, `transaction_state_id`, `currency`, `activity_title`, `money_flow`, `gross`, `fee`, `net`, `currency_symbol`, `currency_id`, `json_data`) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
                $stmt = $pdo->prepare($transactionable_query);
                $stmt->bindParam(1, $data['user_id'], PDO::PARAM_INT);
                $stmt->bindParam(2, $data['reference'], PDO::PARAM_STR);
                $stmt->bindParam(3, $currency_name, PDO::PARAM_STR);
                $stmt->bindParam(4, $trxState, PDO::PARAM_STR);
                $stmt->bindParam(5, $currency, PDO::PARAM_STR);
                $stmt->bindParam(6, $OPay, PDO::PARAM_STR);
                $stmt->bindParam(7, $money_flow, PDO::PARAM_STR);
                $stmt->bindParam(8, $data['amount'], PDO::PARAM_STR);
                $stmt->bindParam(9, $fee, PDO::PARAM_STR);
                $stmt->bindParam(10, $data['amount'], PDO::PARAM_STR);
                $stmt->bindParam(11, $currency_symbol, PDO::PARAM_STR);
                $stmt->bindParam(12, $currency_id, PDO::PARAM_STR);
                $stmt->bindParam(13, $responses['data']['cashierUrl'], PDO::PARAM_STR);
                $stmt->execute();

                // Return success message
                return $responses['data']; //['status' => 'success', 'message' => 'Transaction successful'];
            } else {
                // Handle case where wallet is not found
                return ['status' => 'error', 'message' => 'Wallet not found'];
            }
        } catch (PDOException $e) {
            // Handle database error
            return ['status' => 'error', 'message' => 'Database error: ' . $e->getMessage()];
        }
    } else {
        // Return the response to the frontend
        return ['status' => 'error', 'message' => 'Cashier URL not found in OPay response'];
    }
}

// Handle the POST request
if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    // Get the JSON data from the frontend
    $data = json_decode(file_get_contents('php://input'), true);

    // Call the createOpayRequest function and process the response
    $response = createOpayRequest($data);

    // Handle the response
    header('Content-Type: application/json; charset=UTF-8'); // Set character encoding to UTF-8
    echo json_encode($response);
}
?>