<?php
header('Content-Type: application/json');
require_once 'connector.php';

function updateAccount($userId, $bank_code, $bank_name, $account_number) {
    global $pdo;

    // Validate data here (e.g., required fields, file size, etc.)
    if (empty($userId) || empty($bank_code) || empty($bank_name) || empty($account_number)) {
        return ['status' => 'error', 'message' => 'Please fill in all required fields.'];
    }
    
    	$sqidl = "SELECT * FROM `xxoxx`";
	$result = $conn->query($sqidl);
	$row = $result->fetch_assoc();
	$pskey_scrt = $row["pskey_scrt"]; 
	$pskey_pub = $row["pskey_pub"];

    try {
    	
	    //print_r($jayParsedAr["0"]);
            $curl = curl_init();
            curl_setopt_array($curl, array(CURLOPT_URL => "https://api.paystack.co/bank/resolve?account_number=$account_number&bank_code=$bank_code",
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "GET",
            CURLOPT_HTTPHEADER => array("Authorization: Bearer $pskey_scrt","Cache-Control: no-cache",),
            ));
            $response = curl_exec($curl);
            $err = curl_error($curl);
            curl_close($curl);
            //var_dump($response);
            $jayParsedAry = json_decode($response, true);
            
            $Account_name = $jayParsedAry["data"]["account_name"];
            $Account_number = $jayParsedAry["data"]["account_number"];
            $resolved = $jayParsedAry["message"];
            
            
        // Prepare and execute the SQL query
        $sql = "INSERT INTO account_details account_number = :account_number, account_name = :account_name, bank_name = :bank_name, bank_code = :bank_code, user_id = :user_id";
        $stmt = $pdo->prepare($sql);
        $stmt->bindValue(':account_number', $account_number);
        $stmt->bindValue(':lastName', $lastName);
        $stmt->bindValue(':account_name', $account_name);
        $stmt->bindValue(':bank_name', $bank_name);
        $stmt->bindValue(':bank_code', $bank_code);
        $stmt->bindValue(':userId', $userId);

        if($stmt->execute())
        {
        	return ['status' => 'Success', 'message' => 'Account Updated Successfully'];
        }
        else
        {
        	return ['status' => 'Error', 'message' => 'Error Updating Account'];
        }
    } catch (PDOException $e) {
        return ['status' => 'error', 'message' => 'Error Updating Account: ' . $e->getMessage()];
    }
}

// Handle POST request from form submission
if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    $data = json_decode(file_get_contents('php://input'), true);
    
    
            $account_number = $data["accountNumber"];
            $userid = $data["userId"];
            $bank_code_a = explode(',',$data["bankCode"]);
            $jayParsedAry = json_encode($bank_code_a, true);
            $jayParsedAr = json_decode($jayParsedAry, true);
            
            $bank_code = $jayParsedAr['0'];
            $bank_name = $jayParsedAr['1'];

    // Validate data
    if (empty($userId) || empty($bank_code) || empty($bank_name) || empty($account_number)) {
        return ['status' => 'error', 'message' => 'Please fill in all required fields.'];
    }

    // Update Account
    $result = updateAccount($userId, $bank_code, $bank_name, $account_number);
    echo json_encode($result);
}
?>


<?php
/*
include('include/connector.php');
$sqidl = "SELECT * FROM `xxoxx`";
$result = $conn->query($sqidl);
$row = $result->fetch_assoc();
            
$pskey_scrt = $row["pskey_scrt"]; 
$pskey_pub = $row["pskey_pub"];

            $account_number = $_POST["account_number"];
            $userid = $_POST["userid"];
            $bank_code_a = explode(',',$_POST["bank_code"]);
            $jayParsedAry = json_encode($bank_code_a, true);
            $jayParsedAr = json_decode($jayParsedAry, true);
            
            $bank_code = $jayParsedAr['0'];
            $bank_name = $jayParsedAr['1'];
            
            
            //print_r($jayParsedAr["0"]);
            $curl = curl_init();
            curl_setopt_array($curl, array(CURLOPT_URL => "https://api.paystack.co/bank/resolve?account_number=$account_number&bank_code=$bank_code",
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "GET",
            CURLOPT_HTTPHEADER => array("Authorization: Bearer $pskey_scrt","Cache-Control: no-cache",),
            ));
            $response = curl_exec($curl);
            $err = curl_error($curl);
            curl_close($curl);
            var_dump($response);
            $jayParsedAry = json_decode($response, true);
            
            $Account_name = $jayParsedAry["data"]["account_name"];
            $Account_number = $jayParsedAry["data"]["account_number"];
            $resolved = $jayParsedAry["message"];
            
            $sqlop = "INSERT INTO account_details (`account_number`, `account_name`, `bank_name`, `bank_code`, `user_id`)
            VALUES
            ('$Account_number','$Account_name', '$bank_name', '$bank_code', '$userid')";
		
		
            if($resolved == "Account number resolved")
            {
	            if (mysqli_query($conn, $sqlop))
	            {
	            	echo "Transaction successfully!";
	            }
            }
            else
            {echo "Error: " . $sqlop . ":-" . mysqli_error($conn);}
            
            mysqli_close($conn);
            header("Location:https://setlottonig.com/dev/v6/withdrawal/request?resolved=$resolved");
            */
           
?>