<?php
header('Content-Type: application/json');
require_once 'connector.php';

function verifyUser($email) {
    global $pdo;

    // Validate data here (e.g., required fields, file size, etc.)
    if (empty($email)) {
        return ['status' => 'error', 'message' => 'Email cannot be empty.'];
    }
    $verified = 1;

    try {
        // Prepare and execute the SQL query
        $sql = "UPDATE users SET verified= :verified WHERE email= :email";
        $stmt = $pdo->prepare($sql);

        $stmt->bindValue(':verified ', $verified );
        $stmt->bindValue(':email', $email);

        if($stmt->execute())
        {
        	return ['status' => 'Success', 'message' => 'User Profile Verified Successfully'];
        }
        else
        {
        	return ['status' => 'Error', 'message' => 'Error Verifying User Profile'];
        }
    } catch (PDOException $e) {
        return ['status' => 'error', 'message' => 'Error verifying User: ' . $e->getMessage()];
    }
}

// Handle POST request from form submission
if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    $data = json_decode(file_get_contents('php://input'), true);

    $email = $data['email'];

    // Validate data
    if (empty($email)) {
        return ['status' => 'error', 'message' => 'Email cannot be empty.'];
    }

    // Update User
    $result = verifyUser($email);
    echo json_encode($result);
}
?>